<script lang="ts" setup>
import { ref } from 'vue'
import Avatar from 'primevue/avatar'
import Menu from 'primevue/menu'
import { useUserStore } from '@/stores/user'
import { useMenuStore } from '@/stores/menu'
import { useLoadingStore } from '@/stores/loading'

const userStore = useUserStore()
const menuStore = useMenuStore()
const loadingStore = useLoadingStore()
const menu = ref()

const toggle = (event : Event) => {
  menu.value.toggle(event)
}

if (!menuStore.isLoaded) {
  loadingStore.setLoading()
  await menuStore.loadMenuItems()
  loadingStore.unsetLoading()
}
</script>

<template>
  <div class="flex justify-end h-[60px] pt-1 bg-themeblue-500">
    <div class="flex-auto pl-[16px]">
      <img class="h-[38px] mt-[5px]" src="@/assets/10D.svg" />
    </div>
    <div v-if="userStore.isLoggedIn" class="pr-1">
      <Avatar
        icon="pi pi-user"
        size="large"
        @click="toggle"
        aria-haspopup="true"
        aria-controls="overlay_menu"
        data-test="button-open-menu"
      />
      <Menu
        ref="menu"
        id="overlay_menu"
        :model="menuStore.items"
        :popup="true"
        append-to="body"
        data-test="menu"
      >
        <template #item="{ label, item, props }">
          <router-link v-if="item.route" v-slot="routerProps" :to="item.route" custom>
              <a :href="routerProps.href" v-bind="props.action">
                  <span v-bind="props.icon" />
                  <span v-bind="props.label">{{ label }}</span>
              </a>
          </router-link>
          <a v-else :href="item.url" v-bind="props.action">
              <span v-bind="props.icon" />
              <span v-bind="props.label">{{ label }}</span>
          </a>
    </template>
      </Menu>
    </div>
  </div>
</template>
